#ifndef DV_CGIDATA_H
#define DV_CGIDATA_H

#include <stdexcept>
#include <string>

#include <dvcgi/cgierror.h>

/*! \file
    The Dv::Cgi::cgidata() function retrieves the
    data stream passed to a cgi program.
*/
namespace Dv { namespace Cgi {

/** 
 * Fill the parameter string with the data stream passed to the cgi program.
 * Further processing can be done with Dv::Cgi::formdata.
 *
 * \param data a string that will be filled with the data stream.
 * \exception CgiError is thrown when something goes wrong, e.g.
 *  illegal protocol etc.
 * \see Dv::Cgi::formdata
 */
void cgidata(std::string& data) throw (CgiError);

}}
#endif
