#ifndef DV_CGIERROR_H
#define DV_CGIERROR_H
// $Id: cgierror.h,v 1.4 2002/10/18 19:08:59 dvermeir Exp $

#include <stdexcept>
#include <string>

/*! \file
    Dv::Cgi::CgiError is an runtime_error exception class that may
    be thrown by some dvcgi functions.
*/
namespace Dv { namespace Cgi {

//! A runtime exception thrown by some cgi-related functions.
class CgiError: public std::runtime_error {
public:
  //! Name of class, is prepended to each message argument of the constructor.
  static const std::string NAME;
  //! Constructor, prepends NAME to message to obtain runtime_error::what().
  CgiError(const std::string& message): std::runtime_error(NAME+": "+message) {}
};

}}
#endif
