// $Id: test-cgi.C,v 1.2 2002/10/18 19:08:59 dvermeir Exp $

#include <fstream>
#include <dvcgi/cgi.h>
#include <dvutil/props.h>

// Test program for Dv::Cgi class. It assumes a file field
// ``myfile'' in the corresponding form.

using namespace std;
using namespace Dv::Cgi;

int
main(int,char**) {
static const string MYFILE("myfile");
static const string config_fn("test.conf");

try {
  ifstream	ifs(config_fn.c_str());
  if (!ifs)
    throw runtime_error(config_fn + ": cannot open");
  Dv::Util::Props	config(ifs);

  Cgi	cgi("test-cgi");

  try {
  
    cgi.log() << "started " << endl;
  
    if (config("cgidata")) {
      // Save raw cgi data to file.
      string fn(config["cgidata"]);
      ofstream ofs(fn.c_str());
      ofs << cgi.data();
      }
    
    if (config("cgifile") && cgi.props()(MYFILE)) {
      // Save MYFILE attribute to cgifile
      string fn(config["cgifile"]);
      ofstream ofs(fn.c_str());
      ofs << cgi.props()[MYFILE];
      }
  
    cgi->content_type("text/plain");
  
    // cgi.props() is constant, copy so that
    // we can update it.
    Dv::Util::Props props(cgi.props());
    props.erase(MYFILE);
  
    cgi << props << endl;
    return 0;
    }
  catch (exception& e) {
    cgi.log() << e.what() << endl;
    cgi->content_type("text.plain");
    cgi << e.what() << endl;
    return 1;
    }
  }
catch (exception& e) {
  cerr << e.what() << endl;
  return 1;
  }
}
