#include <dvcgi/sessionserver.h>

const char* html_prefix = 
  "<html>\n"
  "<head><title>test-sessionserver</title></head>\n"
  "<body bgcolor=\"#ffffff\">\n"
  ;

const char* html_suffix = 
  "</body>\n"
  "</html>\n"
  ;

const char* html_form = 
  "<form>\n"
  "<input name=\"number\" type=\"text\" value=\"2\">\n"
  "<input name=\"operation\" type=\"submit\" value=\"add\">\n"
  "<input name=\"operation\" type=\"submit\" value=\"stop\">\n"
  "</form>\n"
  ;

int 
main(int,char**) {
Dv::Cgi::SessionServer client("test-sessionserver", 5*1000,
  "index.html", "http://tinf2.vub.ac.be/index.html");

client.log() << "main()" << std::endl;
try {
  client.header().content_type("text/html").nocache();
  int sum(0);
  while (client) {
    client.log() << "reading operation" << std::endl;
    std::string operation;
    int  n;

    if (client("operation")) {
      client.props() >> "operation" >> operation >> "number" >> n;
      if (operation=="add") {
        sum += n;
        client << html_prefix << "<p>sum = " << sum << "<p>" << html_form << html_suffix << Dv::Cgi::eof;
        }
      else if (operation=="stop") 
        client.disconnect("http://tinf2.vub.ac.be/index.html");
      else
        throw std::runtime_error(std::string("illegal operation:'")+operation+"'");
      }
    else
      client << html_prefix << "<p>sum = " << sum << "<p>" << html_form << html_suffix << Dv::Cgi::eof;
    }
  // timeout
  client.log() << "client connection timed out" << std::endl
  	       << "closing down" << std::endl;
  client.disconnect();
  }
catch (std::runtime_error& e) {
 client.log() << "exception = " << e.what() << std::endl;
 std::cerr << e.what() << std::endl;
 }
}
