// $Id: wwwdecode.C,v 1.4 2002/10/18 19:08:59 dvermeir Exp $

#include	<string>
#include	<ctype.h> // isxdigit, isalnum
#include	"wwwdecode.h"

using namespace std;

namespace Dv { namespace Cgi {
static inline int
hexdigit(char c) { // assert(isxdigit(c))
if (isdigit(c)) 
  return c - '0';
else if (isupper(c))
  return c - 'A' + 10;
else // must be lower case letter
  return c - 'a' +10;
}

string&
www_decode(string& s) {
unsigned int i(0); // input index
unsigned int j(0); // output index
unsigned int len(s.size());
for (i=0; (i<len); ++i,++j)
  switch (s[i]) {
    case '+': s[j] = ' '; break;
    case '%': // the following 2 characters must be hex digits: 0-9,a-f
      if ((i+2<len) && isxdigit(s[i+1]) && isxdigit(s[i+2])) {
	s[j] = hexdigit(s[i+1])* 16 + hexdigit(s[i+2]);
	i += 2;
        }
      else
        s[j] = s[i];
      break;
    default: s[j] = s[i]; break;
    }
s.resize(j);
return s;
}

static unsigned char hexchars[] = "0123456789ABCDEF";

string&
www_encode(const string& sin,string& sout) {
sout.reserve(3*sin.size()+1);
sout.resize(0);
for (unsigned int i=0;(i<sin.size());++i) {
  register char c(sin[i]);
  if (isalnum(c) || (c=='_'))
    sout += c;
  else {
    sout += '%';
    sout += hexchars[static_cast<unsigned char>(c)>>4];  
    sout += hexchars[static_cast<unsigned char>(c)&15];  
    }
  }
return sout;
}
}}
