#ifndef	DVCGI_WWWDECODE_H
#define	DVCGI_WWWDECODE_H
// $Id: wwwdecode.h,v 1.9 2003/08/10 12:35:41 dvermeir Exp $

#include	<string>

/** @file
 *  Simple functions that apply RFC 1738, as used in URLs, to encode
 *  or decode strings.
 *  <ul>
 *  <li> Dv::Cgi::www_decode
 *  <li> Dv::Cgi::www_encode
 *  </ul>
*/

namespace Dv {
namespace Cgi {
/** In-place decode (RFC 1738) of string s.
 * @param s string to be decoded (in-place).
 * @return reference to parameter
 */
std::string& www_decode(std::string& s);
/** Encode (RFC 1738) string.
 * @param sin input string to be encoded.
 * @param sout string that will receive the encoded version of @a sin.
 * @return reference to @a sout.
 */
std::string& www_encode(const std::string& sin, std::string& sout);
}}
#endif
